/* WCECompatibleBitmapBuffer.java -- 
   Copyright (C) 2006 Free Software Foundation, Inc.

This file is part of Mysaifu JVM.

Mysaifu JVM is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

Mysaifu JVM is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mysaifu JVM; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package gnu.java.awt.peer.wce.image;

import java.awt.image.ColorModel;
import java.awt.image.DataBuffer;
import java.awt.image.SampleModel;
import gnu.java.awt.peer.wce.WCEComponentPeer;

public class WCECompatibleBitmapBuffer extends WCEBitmapBuffer {
	/**
	 * ƂȂpeer
	 */
	private final WCEComponentPeer peer;
	
	/**
	 * w肳ꂽpeerƌ݊̂rbg}bv𐶐B
	 */
	public WCECompatibleBitmapBuffer(WCEComponentPeer peer, int width, int height) {
		// CreateCompatibleBitmap()Őrbg}bṽf[^
		// SetPixel()œǂݏ邽߁A1sNZ̃f[^TCYintƂȂ
		super(TYPE_INT, width, height);
		if (peer == null) {
			throw new NullPointerException("peer");
		}
		this.peer = peer;
	}
	
	/**
	 * ΉWCEPeerR|[lgԂ
	 */
	public WCEComponentPeer getWCEComponentPeer() {
		return this.peer;
	}
	
	/**
	 * lCeBurbg}bv쐬ÃnhԂB
	 */
	protected int createBitmapHandle() {
		return createNativeBitmapHandle(getWCEComponentPeer().getWindowHandle(),
										getWidth(),
										getHeight());
	}
	
	private native int createNativeBitmapHandle(int windowHandle, int width, int height);
	
	public int getElem(int bank, int i) {
		return getNativePixel(getBitmapHandle(),
							  (i % this.width), 	// x
							  (i / this.width));	// y
	}
	
	private native int getNativePixel(int bitmapHandle, int x, int y);
	
	public void setElem(int bank, int i, int val) {
		setNativePixel(getBitmapHandle(),
					   (i % this.width),	// x
					   (i / this.width));	// y
	}
	
	private native void setNativePixel(int bitmapHandle, int x, int y);

	/**
	 * ̃C[W̃f[^𒊏o邽߂SampleModel쐬B
	 */
	public SampleModel createCompatibleSampleModel() {
		throw new UnsupportedOperationException("Not implemented");
	}
	
	/**
	 * ̃C[W̃f[^̐FColorModel쐬B
	 */
	public ColorModel createCompatibleColorModel() {
		throw new UnsupportedOperationException("Not implemented");
	}
	
	/**
	 * ̃C[ŴׂẴsNZf[^int[]ƂĕԂB
	 * f[^^CvTYPE_INTȊȌꍇAUnsupportedOperationExceptionthrowB
	 */
	public int[] getAllPixels(int[] pixels) {
		throw new UnsupportedOperationException("Not implemented");
	}
	
	/**
	 * ̃C[W̑Sf[^Aw肳ꂽsNZŒuB
	 * f[^^CvTYPE_INTȊȌꍇAUnsupportedOperationExceptionthrowB
	 */
	public void setAllPixels(int[] pixels) {
		throw new UnsupportedOperationException("Not implemented");
	}

	/**
	 * ̃C[ŴׂẴsNZf[^short[]ƂĕԂB
	 * f[^^CvTYPE_USHORTȊȌꍇAUnsupportedOperationExceptionthrowB
	 */
	public short[] getAllPixels(short[] pixels) {
		throw new UnsupportedOperationException("Not implemented");
	}
	
	/**
	 * ̃C[W̑Sf[^Aw肳ꂽsNZŒuB
	 * f[^^CvTYPE_USHORTȊȌꍇAUnsupportedOperationExceptionthrowB
	 */
	public void setAllPixels(short[] pixels) {
		throw new UnsupportedOperationException("Not implemented");
	}
}
